Attribute VB_Name = "I2Ccommands"
'######################################################################################
'# I need a function that will send data from an array to the write function as bytes #
'#                                                                                    #
'# I need a function that will put the read data into an array                        #
'######################################################################################

Private CurrentValue As Byte

Public Sub Delay(DelayTime As Double)
    Dim J As Double
    Dim I As Integer
    Dim A As Integer
    For J = 1 To DelayTime
        For I = 1 To 120
            A = A
        Next I
    Next J
    
End Sub
Public Sub I2CInit()    'call this immediately after power-on
    'starts or gets reedy for the beginnig in communication
    Dim n As Byte
    
    SDAhigh
    SCLlow
    For n = 0 To 3
        Call StopBit
    Next n
End Sub

Public Sub sendbyte(PortID, value)
Static CurrentValue As Byte
PortOut &H378, CurrentValue And value
CurrentValue = CurrentValue And value
End Sub

Public Sub SetBit(value As Byte)
PortOut &H378, CurrentValue Or value
CurrentValue = CurrentValue Or value
End Sub

Public Sub ClearBit(value As Byte)
On Error GoTo Exit_Sub
PortOut &H378, CurrentValue And (Not value)
CurrentValue = CurrentValue And (Not value)
Exit_Sub:
End Sub

Public Sub FaOpen()
    'opens the Fa pin, to disable the uC in the TV
    'PortOut &H378, 1 * &H8      'portout at address 378(parallel port) set pin 5(D4)
    'sendbyte &H378, 1 * &H8
    ClearBit &H8 + &H20 + &H40
    frmMain.mnuRomCh01On.Checked = True     'MainGui "Config> channel 01" Only selected (defualt)
    frmMain.mnuRomCh02On.Checked = False
    frmMain.mnuRomCh03On.Checked = False
End Sub

Public Sub FaClose()
    'shorts the Fa pins
    'PortOut &H378, 0 * &H8
    SetBit &H8      'this will set pin 5(D4) to
End Sub

Public Sub ChannelOne()
    'Both Relay 1 and 2 off
    'PortOut &H378, 0 * &H20 + 0 * &H40
    'sendbyte &H378, 0 * &H20 + 0 * &H40
    ClearBit &H20 + &H40
    frmMain.mnuRomCh01On.Checked = True     'MainGui "Config> channel 01" Only selected
    frmMain.mnuRomCh02On.Checked = False
    frmMain.mnuRomCh03On.Checked = False
End Sub

Public Sub ChannelTwo()
    'Rrelay 1 on and 2 off
    'PortOut &H378, 1 * &H20 + 0 * &H40
    'sendbyte &H378, 1 * &H20 + 0 * &H40
    ClearBit &H40
    SetBit &H20
    frmMain.mnuRomCh01On.Checked = False
    frmMain.mnuRomCh02On.Checked = True     'MainGui "Config> channel 02" Only selected
    frmMain.mnuRomCh03On.Checked = False
End Sub

Public Sub ChannelThree()
    'Both Relay 1 and 2 on
    'PortOut &H378, 1 * &H20 + 1 * &H40
    SetBit &H40 + &H20
    frmMain.mnuRomCh01On.Checked = False
    frmMain.mnuRomCh02On.Checked = False
    frmMain.mnuRomCh03On.Checked = True     'MainGui "Config> channel 03" Only selected
End Sub

Public Sub SCLhigh()
    'sets clock high
    SetBit &H1
End Sub

Public Sub SCLlow()
    'sets the clock low
    ClearBit &H1
End Sub

Public Sub SDAhigh()
    'sets data line high
    SetBit &H2
End Sub

Public Sub SDAlow()
    'sets data line low
    ClearBit &H2
End Sub

Public Sub GiveAck()
    'give an acknnowlege bit
    SDAlow                   '           _ACK>_
    'Delay (2000)            '          |      |     ______
    SCLhigh                  'sda ______|______|____/
    'Delay (2000)            '          | ____ |
    SCLlow                   'scl_______|/    \|______
    'Delay (2000)            '          |______|
    SDAhigh
    'Delay (2000)
End Sub

Public Sub GetAck()                                             '                      _Ack<_
    'waits and looks for a ack bit                                                ____ |     |
    SDAhigh  ' this doesnt look nessacary, might cause errors   'sda slave_______/    \|_____|______
    SCLhigh                                                     '             _________|_____|
    Do While GetPortBit(&H378, &H1 = 1) 'while scl=1            'scl_________/         |_____|\______
        If GetPortBit(&H378, &H2 = 0) Then ' if sda=0 then
            SCLlow
        End If
    Loop
    Delay (0)
    Delay (0)
End Sub

Public Sub StartBit()
    'sends starting condition
    SCLhigh
    'Delay (2000)
    SDAhigh                  '               _START_
    'Delay (2000)            '             __|__  |
    SDAlow                   'sda_________/  |  \_|______  \
    'Delay (2000)            '        _______|____|_        > Ready
    SCLlow                   'scl____/       |____| \____  /
    'Delay (2000)
    Delay (0)
End Sub

Public Sub SecStartBit()
    'sends a second start bit for big reads or writes
    SDAhigh
    'Delay (2000)
    SCLhigh                                                  '            _2nd Start
    'Delay (2000)                                            '        ____|_    |
    SDAlow                                                   'sda____/    | \___|_______
    'Delay (2000)                                            '           _|_____|_
    SCLlow                                                   'scl_______/ |_____| \_____
    'Delay (2000)
End Sub

Public Sub StopBit()
    'sends a stop condition on the line
    SDAlow
    'Delay (2000)                            '             _STOP_
    SCLhigh                                  '             |    _|___
    'Delay (2000)                            'sda__________|___/ |
    SDAhigh                                  '            _|_____|___
    'Delay (2000)                            'scl________/ |_____|
End Sub

Private Sub SendAddress(I2CAddress As Byte)
    'sends I2C address
    Dim K As Integer
    Dim OneByteI2Caddr(1 To 8) As Byte
    
    OneByteI2Caddr(1) = (I2CAddress And &H80) / &H80
    OneByteI2Caddr(2) = (I2CAddress And &H40) / &H40
    OneByteI2Caddr(3) = (I2CAddress And &H20) / &H20
    OneByteI2Caddr(4) = (I2CAddress And &H10) / &H10
    OneByteI2Caddr(5) = (I2CAddress And &H8) / &H8
    OneByteI2Caddr(6) = (I2CAddress And &H4) / &H4
    OneByteI2Caddr(7) = (I2CAddress And &H2) / &H2
    OneByteI2Caddr(8) = (I2CAddress And &H1) / &H1
    
    For K = 1 To 8
        If OneByteI2Caddr(K) = 1 Then
            SDAhigh
        Else
            SDAlow
        End If
        Delay (20000)
        SCLhigh
        Delay (20000)
        SCLlow
        'MsgBox ("sent one bit")
    Next K
    'GetAck
    SCLhigh
    SCLlow
    MsgBox ("one byte Sent")
End Sub

Private Sub SendData(I2Cdata As Byte)
    'Sends I2C data
    Dim K As Integer
    Dim OneByteData(1 To 8) As Byte
    
    OneByteData(1) = (I2Cdata And &H80) / &H80
    OneByteData(2) = (I2Cdata And &H40) / &H40
    OneByteData(3) = (I2Cdata And &H20) / &H20
    OneByteData(4) = (I2Cdata And &H10) / &H10
    OneByteData(5) = (I2Cdata And &H8) / &H8
    OneByteData(6) = (I2Cdata And &H4) / &H4
    OneByteData(7) = (I2Cdata And &H2) / &H2
    OneByteData(8) = (I2Cdata And &H1) / &H1
    
    For K = 1 To 8
        If OneByteData(K) = 1 Then
            SDAhigh
        Else
            SDAlow
        End If
        
        Delay (20000)
        SCLhigh
        Delay (20000)
        SCLlow
        'MsgBox ("sent one bit")
    Next K
    'GetAck
    SCLhigh
    SCLlow
    MsgBox ("one byte Sent")
End Sub

Public Sub I2Cwrite(ByVal MainAddress As Byte, ByVal SlaveAddress As Byte, ByVal I2Cdata As Byte)
    I2CInit
    StartBit
    MsgBox ("sent a start bit")
'    Select Case (FormWriter.chkAddressSize.value = vbChecked)
 '       Case True
            SendAddress (&HA0)
            'SendAddress (MainAddress)
            SendAddress (SlaveAddress)
            SendData (I2Cdata)
  '      Case False
   '         SendAddress (MainAddress * 2 + &HA0)
    '        SendAddress (SlaveAddress)
     '       SendData (I2Cdata)
    'End Select
    StopBit
    MsgBox ("sent a stop bit")
    Delay (0)
End Sub

'Public Sub I2CLongWrite(Select1Address As Byte, Select2Address As Byte, MainAddress As Byte, SlaveAddress As Byte, I2Cdata As Byte)
 '   I2Cinit
  '  StartBit
   ' SendAddress (255 - Select1Address)
    'SendAddress (255 - Select2Address)
'    SendAddress (255 - MainAddress)            'Model that used this is no longer used at all
 '   SendAddress (255 - SlaveAddress)
  '  SendData (255 - I2Cdata)
   ' StopBit
    'delay (0)
'End Sub

Public Function I2Cread(ByVal MainAddress As Byte, ByVal SlaveAddress As Byte)
    I2CInit
    StartBit
    'Select Case (FormWriter.chkAddressSize.value = vbChecked)
     '   Case True
            SendAddress (&HA0) 'main address
            'SendAddress (MainAddress)
            SendAddress (SlaveAddress)
            SecStartBit
            SendAddress (&HA1) 'main address + 1 (this will set the read flag)
      '  Case False
       '     SendAddress (MainAddress * 2 + &HA0)
        '    SendAddress (SlaveAddress)
         '   SecStartBit
          '  SendAddress (MainAddress + 1)
    'End Select
    I2Cread = I2CReadData
    StopBit
    Delay (10)
End Function


Private Function I2CReadData() As Byte
    Dim J As Boolean
    Dim ReadResult(1 To 8) As Byte
    Dim JStep As Integer
    Dim I As Integer
    
    For JStep = 1 To 8
        J = GetPortBit(&H378, &H2)
        If J = True Then
            I = 1
        Else
            I = 0
        End If
        ReadResult(JStep) = I '* (2 ^ (8 - JStep))
        SCLhigh
        Delay (20000)
        SCLlow
    Next
    SCLhigh
    SCLlow
    I2CReadData = ReadResult
End Function

'Private Function I2CReadData() As Byte
    'reads data back from IC
 '   Dim J As Boolean
  '  Dim i As Integer
    'Dim OneBit As Integer
    'Dim ReadResult As Byte
   ' Dim Jstep As Integer
    
    'ReadResult = 0
'    Jstep = 8
 '   Do While Jstep > 0
  '      J = GetPortBit(&H378, &H2)
        'OneBit = (J And &H2) / &H2
        'If J = True Then
         '   I = 1
        'Else
         '   I = 0
        'End If
   '     ReadResult = ReadResult + J * (2 ^ (Jstep - 1)) '(ReadResult * 2) + OneBit
    '    SCLhigh
     '   Delay (20000)
      '  SCLlow
        'MsgBox ("got one bit")
       ' Jstep = Jstep - 1
'    Loop
 '   GiveAck
  '  SCLhigh
   ' SCLlow
    'I2CReadData = ReadResult
'End Function
